module counter4b (
    input        clk_i,
    input        rst_i,
    input        inc_i,
    input        dec_i,
    output [3:0] num_o
);

    // _q is the output of the register
    // _d is the input of the register
    reg [3:0] num_q, num_d;

    // connect register output to module output
    assign num_o = num_q;

    // implement the following sequential logic:
    //   update: 
    //     always at posedge of clock, num_q <= num_d
    //     when asynchronous reset is high, num_q <= 0
    //   evaluate:
    //     when inc_i == 1, num_d = num_q + 1
    //     when dec_i == 1, num_d = num_q - 1
    //     otherwise num_d = num_q

endmodule
